import * as fs from 'fs';
import * as stream from 'stream';

interface IGetFileFromDisksOptions {
  /** Number of the disk where the local file header starts */
  diskStart: number;
  /** Offset into the start of the disk where the local file header starts. */
  offset: number;
  /** Length of the stored file (compressed size + optional 12 byte encryption header), but excluding the length of the local file header. */
  storedSize: number;
}

/** Takes a list of ReadableStreams (the disks), as well as the offset and length, and returns a stream for just one file. */
export default function getFileFromDisks(disks: string[], { diskStart, offset, storedSize }: IGetFileFromDisksOptions): stream.Readable {
  const diskStreams = disks.map((fileName) => fs.createReadStream(fileName));
  //TODO: Can local file header also be spread across multiple disks, or only the payload?
  //Read local file header
  //...

  //Create new stream that concatenates disks until storedSize is reached, then ends the stream.
  const outputStream = new stream.Readable();
  //...
  return outputStream;
}
